package com.example.what_the_fantasy.data.model

import androidx.compose.ui.res.stringResource
import com.example.what_the_fantasy.R
import com.google.gson.JsonDeserializationContext
import com.google.gson.JsonDeserializer
import com.google.gson.JsonElement
import com.google.gson.JsonParseException
import com.google.gson.JsonPrimitive
import com.google.gson.JsonSerializationContext
import com.google.gson.JsonSerializer
import java.lang.reflect.Type

enum class SrcType (val value: String) {
    Movie("movie" ),
    VideoGame("videoGame"),
    Series("series");

    companion object {
        fun fromCode(value: Int): SrcType? = SrcType.values().find {
            if (value==0){
                it.value == "movie"
            }
            else if (value==1){
                it.value == "videoGame"
            }
            else{
                it.value == "series"
            }
        }
    }
}

class SrcTypeAdapter : JsonSerializer<SrcType>, JsonDeserializer<SrcType> {
    override fun serialize(
        src: SrcType?,
        typeOfSrc: Type?,
        context: JsonSerializationContext?
    ): JsonElement = JsonPrimitive(src?.value)

    override fun deserialize(
        json: JsonElement?,
        typeOfT: Type?,
        context: JsonDeserializationContext?
    ): SrcType {
        val value = json?.asInt
        return SrcType.fromCode(value ?: throw JsonParseException("Code null"))
            ?: throw JsonParseException("Unknown Status code: $value")
    }

}